% Bungy Jumping with rigid object
% Andy Ruina,  April 12, 2019
% THIS VERSION IS MINIMAL... with MINIMAL COMMENTING
% _Not_ a model for homework.
clear all,  close all

%PARAMETERS
p.L0  = 10; p.k   = 1; p.ell= 10; p.w= 5; p.g= 1; %Problem parameters
p.m = 10;   p.IG  = 500;

%INITIAL CONDITIONS
rG0 = [20; 5]; theta0 = pi/2; vG0 = [0; 0]; omega0 = 0;
z0 = [rG0; theta0; vG0; omega0];

%SETUP ODE SOLUTION
tarray            = linspace(0,200,1000);   
f                 = @(t,z)  mybungy(z,p);  

%SOLVE ODES HERE 
[tarray, zarray]  = ode45(f, tarray, z0);
xG  = zarray(:,1);    yG = zarray(:,2);   theta = zarray(:,3); 

%DRAW A BOX, 
box0 = [-p.ell/2 -p.w/2 0
         p.ell/2 -p.w/2 0
         p.ell/2  p.w/2 0
        - p.ell/2 p.w/2 0
        -p.ell/2 -p.w/2 0]';     

%ANIMATION LOOP
for i = 2:length(tarray)
box = rotatebytheta(box0, theta(i)) + [xG(i);yG(i);0];

spring = [ 0  box(1,3)
           0  box(2,3)];  %from origin to corner of box

%PLOT BOX AND SPRING AND POINTS
plot(spring(1,:),spring(2,:)); hold on 
plot(box(1,:), box(2,:));      hold off  

axis equal  
axis([-40 40 -50 20]); 

pause(.01) 
shg
end %End animation loop

% RHS function
function zdot = mybungy(z,p)
rG   = [z(1:2);0]; theta = z(3); % Unpack the state variables
vG   = [z(4:5);0]; omega = z(6); 
jhat = [ 0; 1; 0];               

rGA0    = [ p.ell/2; p.w/2; 0 ];     % A rel. to G, before rotat.
rGA     = rotatebytheta(rGA0,theta); % function defined below 
rA      = rG + rGA;   L = norm(rA);   lambdaA = rA/L;       

Tspring =   p.k*(L - p.L0);  
Fspring = - Tspring * lambdaA;  

rGdot    = vG(1:2);  %Next 6 lines are the 6 ODEs   
thetadot = omega;
vGdot    = (Fspring - p.m * p.g * jhat)/p.m;  % LMB
      vGdot  = vGdot(1:2);  
omegadot = cross(rGA,Fspring) / p.IG;   % AMB 
    omegadot = omegadot(3);

zdot = [rGdot; thetadot;  vGdot;  omegadot];
end  %END of RHS FUNCTION

%%%%%%%%%%%%%%%%%
function p = rotatebytheta(p0,theta)
c = cos(theta); s = sin(theta);
R = [c -s  0;  s  c  0; 0  0  1 ]; 
p = R*p0;        
end  

